unit unMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, ExtCtrls, StrUtils, Menus, IniFiles, Registry,
  Consts;

type
  TForm1 = class(TForm)
    dlgOpen: TOpenDialog;
    dlgSave: TSaveDialog;
    pgOptions: TPageControl;
    tabInput: TTabSheet;
    tabOutput: TTabSheet;
    tabBitrate: TTabSheet;
    tabFilter: TTabSheet;
    tabComment: TTabSheet;
    edtInput: TEdit;
    edtOutput: TEdit;
    butInputOpen: TButton;
    rgrInputType: TRadioGroup;
    cbxSampleFreq: TComboBox;
    Label2: TLabel;
    butOutputPath: TButton;
    rgpOutputType: TRadioGroup;
    flgDiffBlock: TCheckBox;
    Label3: TLabel;
    edtStat: TEdit;
    Label4: TLabel;
    flgVorbis: TCheckBox;
    flgFreeformat: TCheckBox;
    flgCompRatio: TCheckBox;
    edtCompRatio: TEdit;
    flgScale: TCheckBox;
    edtScale: TEdit;
    flgUseATHMask: TCheckBox;
    flgNoATH: TCheckBox;
    Label5: TLabel;
    edtATH: TEdit;
    Label6: TLabel;
    flgTempMask: TCheckBox;
    flgShortBlock: TCheckBox;
    flgVoiceMode: TCheckBox;
    flgPresets: TCheckBox;
    cbxPresets: TComboBox;
    flgForceInput: TCheckBox;
    flgDefault: TCheckBox;
    rbutCBR: TRadioButton;
    rbutABR: TRadioButton;
    rbutVBR: TRadioButton;
    grpCBR: TGroupBox;
    grpABR: TGroupBox;
    grpVBR: TGroupBox;
    cbxCBR: TComboBox;
    Label7: TLabel;
    Label8: TLabel;
    cbxABR: TComboBox;
    cbxVBRMode: TComboBox;
    Label9: TLabel;
    Label10: TLabel;
    cbxVBRQuality: TComboBox;
    Label11: TLabel;
    cbxMinBitrate: TComboBox;
    Label12: TLabel;
    cbxMaxBitrate: TComboBox;
    flgSupport: TCheckBox;
    flgLameTagDis: TCheckBox;
    grpStream: TGroupBox;
    Label13: TLabel;
    cbxEmp: TComboBox;
    flgCopyright: TCheckBox;
    flgNonOriginal: TCheckBox;
    flgErrorProtection: TCheckBox;
    flgBitRes: TCheckBox;
    flgMaxISO: TCheckBox;
    cbxNoise: TComboBox;
    Label14: TLabel;
    grpFilter: TGroupBox;
    Label15: TLabel;
    edtLowPass: TEdit;
    Label16: TLabel;
    Label17: TLabel;
    edtLowPassWidth: TEdit;
    Label18: TLabel;
    Label19: TLabel;
    edtHighPass: TEdit;
    Label20: TLabel;
    Label21: TLabel;
    edtHighPassWidth: TEdit;
    Label22: TLabel;
    Label23: TLabel;
    edtOutputSample: TEdit;
    Label24: TLabel;
    Label25: TLabel;
    edtTonality: TEdit;
    Label26: TLabel;
    grpOutput: TGroupBox;
    flgNoProgress: TCheckBox;
    flgBlankScreen: TCheckBox;
    flgAllUseFull: TCheckBox;
    grpID3Tag: TGroupBox;
    Label27: TLabel;
    edtSongName: TEdit;
    Label28: TLabel;
    edtArtist: TEdit;
    Label29: TLabel;
    edtAlbum: TEdit;
    Label30: TLabel;
    edtComment: TEdit;
    Label31: TLabel;
    edtTrackNumber: TEdit;
    Label32: TLabel;
    edtYear: TEdit;
    Label33: TLabel;
    cbxGenre: TComboBox;
    rbut1stOnly: TRadioButton;
    rbut2ndOnly: TRadioButton;
    rbutBoth: TRadioButton;
    flg1stEmpty: TCheckBox;
    flg2ndEmpty: TCheckBox;
    flgNoFilter: TCheckBox;
    edtCommandLine: TMemo;
    mnuMain: TMainMenu;
    mnuSet: TMenuItem;
    mnuLamePath: TMenuItem;
    mnuSave: TMenuItem;
    mnuLoad: TMenuItem;
    mnuEncode: TMenuItem;
    mnuRun: TMenuItem;
    mnuRefresh: TMenuItem;
    mnuExit: TMenuItem;
    stsString: TStatusBar;
    flgMP3Decode: TCheckBox;
    flgWavHeader: TCheckBox;
    flgScaleLeft: TCheckBox;
    flgScaleRight: TCheckBox;
    edtScaleLeft: TEdit;
    edtScaleRight: TEdit;
    Label1: TLabel;
    Label34: TLabel;
    Label35: TLabel;
    mnuLanguage: TMenuItem;
    mnuEnglish: TMenuItem;
    mnuRussian: TMenuItem;
    flgReadOnly: TCheckBox;
    flgMonoDownmix: TCheckBox;
    flgHist: TCheckBox;
    flgLameTagEn: TCheckBox;
    procedure butLameOpenClick(Sender: TObject);
    procedure butInputOpenClick(Sender: TObject);
    procedure rgpOutputTypeClick(Sender: TObject);
    procedure flgMP3DecodeClick(Sender: TObject);
    procedure flgUseATHMaskClick(Sender: TObject);
    procedure flgNoATHClick(Sender: TObject);
    procedure flgPresetsClick(Sender: TObject);
    procedure flgDefaultClick(Sender: TObject);
    procedure rbutCBRClick(Sender: TObject);
    procedure rbutABRClick(Sender: TObject);
    procedure rbutVBRClick(Sender: TObject);
    procedure flgNoFilterClick(Sender: TObject);
    procedure rbut1stOnlyClick(Sender: TObject);
    procedure rbut2ndOnlyClick(Sender: TObject);
    procedure rbutBothClick(Sender: TObject);
    procedure rgrInputTypeClick(Sender: TObject);
    procedure cbxSampleFreqChange(Sender: TObject);
    procedure flgForceInputClick(Sender: TObject);
    procedure butOutputPathClick(Sender: TObject);
    procedure flgMonoDownmixClick(Sender: TObject);
    procedure flgDiffBlockClick(Sender: TObject);
    procedure edtStatChange(Sender: TObject);
    procedure flgVorbisClick(Sender: TObject);
    procedure flgFreeformatClick(Sender: TObject);
    procedure flgWavHeaderClick(Sender: TObject);
    procedure flgCompRatioClick(Sender: TObject);
    procedure edtCompRatioChange(Sender: TObject);
    procedure flgScaleClick(Sender: TObject);
    procedure edtScaleChange(Sender: TObject);
    procedure edtATHChange(Sender: TObject);
    procedure flgTempMaskClick(Sender: TObject);
    procedure flgShortBlockClick(Sender: TObject);
    procedure flgVoiceModeClick(Sender: TObject);
    procedure cbxPresetsChange(Sender: TObject);
    procedure cbxCBRChange(Sender: TObject);
    procedure cbxABRChange(Sender: TObject);
    procedure cbxVBRModeChange(Sender: TObject);
    procedure cbxVBRQualityChange(Sender: TObject);
    procedure cbxMinBitrateChange(Sender: TObject);
    procedure cbxMaxBitrateChange(Sender: TObject);
    procedure flgSupportClick(Sender: TObject);
    procedure flgLameTagDisClick(Sender: TObject);
    procedure flgHistClick(Sender: TObject);
    procedure flgCopyrightClick(Sender: TObject);
    procedure flgNonOriginalClick(Sender: TObject);
    procedure flgErrorProtectionClick(Sender: TObject);
    procedure flgBitResClick(Sender: TObject);
    procedure flgMaxISOClick(Sender: TObject);
    procedure cbxEmpChange(Sender: TObject);
    procedure cbxNoiseChange(Sender: TObject);
    procedure edtLowPassChange(Sender: TObject);
    procedure edtLowPassWidthChange(Sender: TObject);
    procedure edtHighPassChange(Sender: TObject);
    procedure edtHighPassWidthChange(Sender: TObject);
    procedure edtOutputSampleChange(Sender: TObject);
    procedure edtTonalityChange(Sender: TObject);
    procedure flgNoProgressClick(Sender: TObject);
    procedure flgAllUseFullClick(Sender: TObject);
    procedure flgBlankScreenClick(Sender: TObject);
    procedure edtSongNameChange(Sender: TObject);
    procedure edtArtistChange(Sender: TObject);
    procedure edtAlbumChange(Sender: TObject);
    procedure edtYearChange(Sender: TObject);
    procedure edtTrackNumberChange(Sender: TObject);
    procedure cbxGenreChange(Sender: TObject);
    procedure edtCommentChange(Sender: TObject);
    procedure flg1stEmptyClick(Sender: TObject);
    procedure flg2ndEmptyClick(Sender: TObject);
    procedure butExitClick(Sender: TObject);
    procedure butReadyClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure PanelHint(Sender: TObject);
    procedure mnuSaveClick(Sender: TObject);
    procedure mnuLoadClick(Sender: TObject);
    procedure flgScaleLeftClick(Sender: TObject);
    procedure flgScaleRightClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure mnuEnglishClick(Sender: TObject);
    procedure mnuRussianClick(Sender: TObject);
    procedure flgReadOnlyClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  strLamePath: String;
  strdlgLame: String;
  strdlgLameFilter: String;
  strdlgOpen: String;
  strdlgChange: String;
  strdlgFileFilter: String;
  strEndProgram: String;
  strNoLamePath: String;
  strNoInputFile: String;
  strNoOutputFile: String;
  strRun: String;
  strdlgSaveConf: String;
  strdlgRestConf: String;
  strdlgFilterConf: String;
  bytLanguage: Byte;
  procedure SetCommandLine();
  procedure SetDefaultCommandLine();
  procedure SwitchLanguage();
implementation

{$R *.dfm}
procedure SwitchLanguage();

begin
   with Form1 do
   begin
      case bytLanguage of
      0: //English
      begin
        mnuEnglish.Checked := True;
        mnuRussian.Checked := False;

        strdlgLame := 'Specify path to the lame.exe';
        strdlgLameFilter := 'lame.exe|lame.exe';
        strdlgOpen := 'Specify path to the input file';
        strdlgChange := 'Specify path to the output file';
        strdlgFileFilter := 'Music files WAV|*.wav; *.mpa|MP3-files|*.mp3|All files|*.*';
        strEndProgram := 'Extit program?';
        strNoLamePath := 'You must specify path to the lame.exe';
        strNoInputFile := 'No input file selected';
        strNoOutputFile := 'No output file selected';
        strRun := 'Start processing?';
        strdlgSaveConf := 'Specify configuration file';
        strdlgRestConf := 'Select configuration file';
        strdlgFilterConf := 'All files|*.*';

        mnuSet.Caption := 'Settings';
        mnuLamePath.Caption := 'Path to lame.exe';
        mnuLamePath.Hint := 'Set path to lame.exe';
        mnuSave.Caption := 'Save settings';
        mnuSave.Hint := 'Save current set of options';
        mnuLoad.Caption := 'Restore settings';
        mnuLoad.Hint := 'Restore previously saved settings';
        mnuLanguage.Caption := 'Language';
        mnuLanguage.Hint := 'Switch interface language';

        mnuEncode.Caption := 'Coding';
        mnuRun.Caption := 'Run';
        mnuRun.Hint := 'Run encoding with selected options';
        mnuRefresh.Caption := 'Refresh command line';
        mnuRefresh.Hint := 'Refresh command line';

        mnuExit.Caption := 'Exit';
        mnuExit.Hint := 'Exit program';

        tabInput.Caption := 'Input file';
        tabInput.Hint := 'Input file options';
        butInputOpen.Caption := 'Open';
        butInputOpen.Hint := 'Select input file';
        edtInput.Hint := 'Input file location';
        rgrInputType.Caption := 'Input file type';
        rgrInputType.Hint := 'Set type of input file';
        Label2.Caption := 'Sample rate, kHz';
        cbxSampleFreq.Hint := 'Set input file sample rate';
        flgForceInput.Caption := 'force byte-swapping of input';
        flgForceInput.Hint := 'Swap bytes in the input file (and output file when using --decode)';
        flgMP3Decode.Caption := 'Decode MP3';
        flgWavHeader.Caption := 'disable writing the WAV header';
        flgWavHeader.Hint := 'The output will be raw pcm, native endian format';
        flgReadOnly.Caption := 'View only';
        flgReadOnly.Hint := 'Allow/disallow the command line correction';

        tabOutput.Caption := 'Output file';
        tabOutput.Hint := 'Output file options';
        edtOutput.Hint := 'Output file location';
        butOutputPath.Caption := 'Change';
        butOutputPath.Hint := 'Change output file location';
        rgpOutputType.Caption := 'Output file type';
        rgpOutputType.Hint := 'Set type of output file';
        flgMonoDownmix.Caption := 'downmix stereo input file to mono .mp3 ';
        flgMonoDownmix.Hint := 'This option is only needed in the case of raw PCM stereo input';
        flgDiffBlock.Caption := 'allow block types to differ between channels';
        flgDiffBlock.Hint := 'Allows the left and right channels to use different block types';
        label3.Caption := 'Show statictics every';
        label4.Caption := 'sec.';
        flgVorbis.Caption := 'Encode using Ogg Vorbis (.ogg) instead of mp3';
        flgFreeformat.Caption := 'produce a free format bitstream';
        flgFreeformat.Hint := 'LAME will produce a fixed bitrate, free format bitstream';
        flgCompRatio.Caption := 'Select bitrate for compression 1:';
        edtCompRatio.Left := 325;
        flgScale.Caption := 'multiply PCM input by';
        flgScale.Hint := 'This just multiplies the PCM data';
        label1.Caption := ' ';
        label34.Caption := ' ';
        label35.Caption := ' ';
        flgScaleLeft.Caption := 'scale left channel by';
        flgScaleLeft.Hint := 'This just multiplies the PCM data';
        flgScaleRight.Caption := 'scale right channel by';
        flgScaleRight.Hint := 'This just multiplies the PCM data';
        flgUseATHMask.Caption := 'only use masking from the ATH ';
        flgUseATHMask.Hint := 'This option causes LAME to ignore the output of the psy-model and only use masking from the ATH';
        flgNoATH.Caption := 'disable ATH';
        label5.Caption := 'lower the ATH by';
        flgTempMask.Caption := 'disable temporal masking ';
        flgShortBlock.Caption := 'Use short blocks';
        flgPresets.Caption := 'Use prests';
        cbxPresets.Left := 100;
        cbxPresets.Items.Clear;
        cbxPresets.Items.Add('Phone');
        cbxPresets.Items.Add('Voice');
        cbxPresets.Items.Add('Radio');
        cbxPresets.Items.Add('Tape');
        cbxPresets.Items.Add('Hi-fi');
        cbxPresets.Items.Add('Studio');
        cbxPresets.Text := 'Phone';
        flgVoiceMode.Caption := 'Experimental voice mode';
        flgDefault.Caption := 'Use default settings';
        flgDefault.Hint := 'Use some quality improvements';

        tabBitrate.Caption := 'Bitrate';
        tabBitrate.Hint := 'Output file bitrate settings';
        rbutCBR.Caption := 'Constant bitrate';
        label7.Caption := 'Bitrate, kB/s';
        rbutABR.Caption := 'Average bitrate';
        label8.Caption := 'Bitrate, kB/s';
        rbutVBR.Caption := 'Variable bitrate';
        label9.Caption := 'Variable bitrate routine';
        label10.Caption := 'Quality';
        label11.Caption := 'Min bitrate';
        label12.Caption := 'Max bitrate';
        flgSupport.Caption := 'strictly enforce the -b option, for use with players that do not support low bitrate mp3';
        flgLameTagDis.Caption := 'disable writing LAME Tag';
        flgLameTagEn.Caption := 'enable and force writing LAME Tag';
        label13.Caption := 'De-emphasis';
        flgBitRes.Caption := 'Disable the bit reservoir';
        flgMaxISO.Caption := 'Comply as much as possible to ISO MPEG spec';

        tabFilter.Caption := 'Filters';
        tabFilter.Hint := 'Various filters and noise reduction';        
        label14.Caption := 'Noise shaping';
        flgNoFilter.Caption := 'Disable all filters';
        grpFilter.Caption := 'Filters';
        label15.Caption := 'Lowpass cut';
        label17.Caption := 'Lowpass bandwidth';
        label19.Caption := 'Highpass cut';
        label21.Caption := 'Highpass bandwidth';
        label23.Caption := 'Sampling frequency of output file';
        label25.Caption := 'Specify range of tonality calculation';
        edtTonality.Left := 190;
        edtLowPass.Left := 190;
        edtLowPassWidth.Left := 190;
        edtHighPass.Left := 190;
        edtHighPassWidth.Left := 190;
        edtOutputSample.Left := 190;
        label16.Left := 246;
        label18.Left := 246;
        label20.Left := 246;
        label22.Left := 246;
        label24.Left := 246;
        label26.Left := 246;

        tabComment.Caption := 'Output info';
        grpOutput.Caption := 'Output options';
        grpOutput.Hint := 'Output options';
        flgNoProgress.Caption := 'Don''t print progress report, VBR histograms';
        flgBlankScreen.Caption := 'Don''t print anything on screen';
        flgAllUseFull.Caption := 'Print a lot of useful information';
        flgHist.Caption := 'Disable VBR histogram display';
        grpID3Tag.Caption := 'ID3 tag';
        grpID3Tag.Hint := 'ID3 tag options';
        label27.Caption := 'Song title';
        label28.Caption := 'Artist';
        label29.Caption := 'Album';
        label32.Caption := 'Year';
        label31.Caption := 'Track number';
        label33.Caption := 'Genre';
        label30.Caption := 'Comment';
        rbut1stOnly.Caption := 'Add only a version 1 tag';
        rbut2ndOnly.Caption := 'Add only a version 2 tag';
        rbutBoth.Caption := 'Force addition of version 2 tag';
        flg1stEmpty.Caption := 'Pad version 1 tag with spaces instead of nulls';
        flg2ndEmpty.Caption := 'Pad version 2 tag with extra 128 bytes';

      end;

      1:  //Russian
      begin
        mnuRussian.Checked := True;
        mnuEnglish.Checked := False;

        strdlgLame := '   lame.exe';
        strdlgLameFilter := ' lame.exe|lame.exe';
        strdlgOpen := '    ';
        strdlgChange := '    ';
        strdlgFileFilter := '  WAV|*.wav; *.mpa|MP3 |*.mp3| |*.*';
        strEndProgram := ' ?';
        strNoLamePath := '    lame.exe';
        strNoInputFile := '   ';
        strNoOutputFile := '   ';
        strRun := ' ?';
        strdlgSaveConf := '  ';
        strdlgRestConf := '  ';
        strdlgFilterConf := ' |*.*';

        mnuSet.Caption := '';
        mnuLamePath.Caption := '  lame.exe';
        mnuLamePath.Hint := '   lame.exe';
        mnuSave.Caption := ' ';
        mnuSave.Hint := '    ';
        mnuLoad.Caption := ' ';
        mnuLoad.Hint := '      ';
        mnuLanguage.Caption := 'Language';
        mnuLanguage.Hint := '  ';

        mnuEncode.Caption := '';
        mnuRun.Caption := '';
        mnuRun.Hint := ' ,   ';
        mnuRefresh.Caption := '  ';

        mnuExit.Caption := '';
        mnuExit.Hint := ' ';

        tabInput.Caption := ' ';
        tabInput.Hint := '  ';
        butInputOpen.Caption := '';
        butInputOpen.Hint := '  ';
        edtInput.Hint := '  ';
        rgrInputType.Caption := '  ';
        rgrInputType.Hint := '   ';
        Label2.Caption := ' , kHz';
        cbxSampleFreq.Hint := '    ';
        flgForceInput.Caption := '  ';
        flgForceInput.Hint := '    (    --decode)';
        flgMP3Decode.Caption := ' MP3';
        flgWavHeader.Caption := '   WAV';
        flgWavHeader.Hint := '     raw pcm,    ';
        flgReadOnly.Caption := ' ';
        flgReadOnly.Hint := '/   ';

        tabOutput.Caption := ' ';
        tabOutput.Hint := '  ';
        edtOutput.Hint := '  ';
        butOutputPath.Caption := '';
        butOutputPath.Hint := '   ';
        rgpOutputType.Caption := '  ';
        rgpOutputType.Hint := '   ';
        flgMonoDownmix.Caption := '      .mp3 ';
        flgMonoDownmix.Hint := '     raw-PCM  ';
        flgDiffBlock.Caption := '    ';
        flgDiffBlock.Hint := '         ';
        label3.Caption := '  ';
        label4.Caption := '';
        flgVorbis.Caption := '   Ogg Vorbis (.ogg)';
        flgFreeformat.Caption := ' "" ';
        flgFreeformat.Hint := '   LAME     8  640 kbps.';
        flgCompRatio.Caption := ' bitrate    1:';
        edtCompRatio.Left := 407;
        flgScale.Caption := '  PCM  ';
        flgScale.Hint := '  ';
        label1.Caption := '';
        label34.Caption := '';
        label35.Caption := '';
        flgScaleLeft.Caption := '   ';
        flgScaleLeft.Hint := '  ';
        flgScaleRight.Caption := '   ';
        flgScaleRight.Hint := '  ';
        flgUseATHMask.Caption := '  ATH ';
        flgUseATHMask.Hint := '   LAME  - ,    ATH';
        flgNoATH.Caption := ' ATH';
        label5.Caption := ' ATH ';
        flgTempMask.Caption := '   ';
        flgShortBlock.Caption := '  ';
        flgPresets.Caption := '  ';
        cbxPresets.Left := 262;
        cbxPresets.Items.Clear;
        cbxPresets.Items.Add('');
        cbxPresets.Items.Add('');
        cbxPresets.Items.Add('');
        cbxPresets.Items.Add('');
        cbxPresets.Items.Add('Hi-fi');
        cbxPresets.Items.Add('');
        cbxPresets.Text := '';        
        flgVoiceMode.Caption := '  ';
        flgDefault.Caption := '   ';
        flgDefault.Hint := 'Use some quality improvements';

        tabBitrate.Caption := '';
        tabBitrate.Hint := '   ';
        rbutCBR.Caption := ' ';
        label7.Caption := ', kB/s';
        rbutABR.Caption := ' ';
        label8.Caption := ', kB/s';
        rbutVBR.Caption := ' ';
        label9.Caption := '  ';
        label10.Caption := '';
        label11.Caption := ' ';
        label12.Caption := ' ';
        flgSupport.Caption := ' MP3-,    ';
        flgLameTagDis.Caption := '  LAME ';
        flgLameTagEn.Caption := '    LAME ';
        label13.Caption := '-';
        flgBitRes.Caption := '  ';
        flgMaxISO.Caption := '   ISO MPEG';

        tabFilter.Caption := '';
        tabFilter.Hint := '   ';
        label14.Caption := '';
        flgNoFilter.Caption := '  ';
        grpFilter.Caption := '';
        label15.Caption := '  -';
        label17.Caption := ' -';
        label19.Caption := '  -';
        label21.Caption := ' -';
        label23.Caption := '   ';
        label25.Caption := '  ';
        edtTonality.Left := 258;
        edtLowPass.Left := 258;
        edtLowPassWidth.Left := 258;
        edtHighPass.Left := 258;
        edtHighPassWidth.Left := 258;
        edtOutputSample.Left := 258;
        label16.Left := 314;
        label18.Left := 314;
        label20.Left := 314;
        label22.Left := 314;
        label24.Left := 314;
        label26.Left := 314;

        tabComment.Caption := '    ';
        grpOutput.Caption := '   ';
        grpOutput.Hint := '  ';
        flgNoProgress.Caption := '     ';
        flgBlankScreen.Caption := '    ';
        flgAllUseFull.Caption := '   ';
        flgHist.Caption := '    ';
        grpID3Tag.Caption := 'ID3 tag';
        grpID3Tag.Hint := '   MP3-';
        label27.Caption := ' ';
        label28.Caption := '';
        label29.Caption := '';
        label32.Caption := '';
        label31.Caption := ' ';
        label33.Caption := '';
        label30.Caption := '';
        rbut1stOnly.Caption := '  1-  ID3 tag';
        rbut2ndOnly.Caption := '  2-  ID3 tag';
        rbutBoth.Caption := '  ';
        flg1stEmpty.Caption := '    1-  ';
        flg2ndEmpty.Caption := '  2-  128 ';        
      end;
   end;
end;
end;

procedure SetDefaultCommandLine();
var strTemp, strFinalString: String;

begin
with Form1 do
begin
    strTemp := strLamePath;
    if pos(' ', strTemp) <> 0 then
        strFinalString := '"' + strTemp + '"'
    else
        strFinalString := strTemp;

    strFinalString := strFinalString + ' -h';

    strTemp := trim(edtInput.Text);
    if strTemp <> '' then
    begin
        if pos(' ', strTemp) <> 0 then
            strFinalString := strFinalString + ' "' + strTemp + '"'
        else
            strFinalString := strFinalString + ' ' + strTemp;
    end;

    strTemp := trim(edtOutput.Text);
    if strTemp <> '' then
    begin
        if pos(' ', strTemp) <> 0 then
            strFinalString := strFinalString + ' "' + strTemp + '"'
        else
            strFinalString := strFinalString + ' ' + strTemp;
    end;

    edtCommandLine.Text := strFinalString;

end;
end;

procedure SetCommandLine();

var strTemp, strTempID3, strFinalString: String;

begin
with Form1 do
begin
    strTemp := strLamePath;
    if pos(' ', strTemp) <> 0 then
        strFinalString := '"' + strTemp + '"'
    else
        strFinalString := strTemp;

    case rgrInputType.ItemIndex of
        0 : strTemp := ' --mp1input';
        1 : strTemp := ' --mp2input';
        2 : strTemp := ' --mp3input';
        3 : strTemp := ' --ogginput';
        4 : strTemp := ' -r';
    else
        strTemp := '';    
    end;
    strFinalString := strFinalString + strTemp;

    if cbxSampleFreq.Text <> '44.1' then
        strFinalString := strFinalString + ' -s ' + cbxSampleFreq.Text;

    if flgForceInput.Checked then
        strFinalString := strFinalString + ' -x';

    case rgpOutputType.ItemIndex of
        0 : strTemp := ' -m s';
        1 : strTemp := ' -m j';
        2 : strTemp := ' -m f';
        3 : strTemp := ' -m m';
        4 : strTemp := ' -m a';
    end;
    strFinalString := strFinalString + strTemp;

    if flgMonoDownmix.Enabled and flgMonoDownmix.Checked then
        strFinalString := strFinalString + ' -a';

    if flgDiffBlock.Checked then
        strFinalString := strFinalString + ' -d';

    strTemp := trim(edtStat.Text);
    if strTemp <> '' then
        strFinalString := strFinalString + ' --disptime ' + strTemp;

    if flgVorbis.Checked then
        strFinalString := strFinalString + ' --ogg';

    if flgFreeformat.Checked then
        strFinalString := strFinalString + ' --freeformat';

    if flgMP3Decode.Checked then
        strFinalString := strFinalString + ' --decode';

    if flgWavHeader.Enabled and flgWavHeader.Checked then
        strFinalString := strFinalString + ' -t';

    strTemp := trim(edtCompRatio.Text);
    if edtCompRatio.Enabled then
    begin
        if strTemp <> '' then
            strFinalString := strFinalString + ' --comp ' + strTemp;
    end;

    strTemp := trim(edtScale.Text);
    if edtScale.Enabled then
    begin
        if strTemp <> '' then
            strFinalString := strFinalString + ' --scale ' + strTemp;
    end;

    if flgUseATHMask.Checked then
        strFinalString := strFinalString + ' --athonly';

    if flgNoATH.Checked then
        strFinalString := strFinalString + ' --noath';

    strTemp := trim(edtATH.Text);
    if strTemp <> '' then
    begin
        if not flgNoATH.Checked then
            strFinalString := strFinalString + ' --athlower ' + strTemp;
    end;

    if flgTempMask.Checked then
        strFinalString := strFinalString + ' --notemp';

    if flgShortBlock.Checked then
        strFinalString := strFinalString + ' --short';

    if flgVoiceMode.Checked then
        strFinalString := strFinalString + ' --voice';

    if cbxPresets.Enabled then
    begin
        case cbxPresets.ItemIndex of
            0 : strTemp := ' phone';
            1 : strTemp := ' voice';
            2 : strTemp := ' fm';
            3 : strTemp := ' tape';
            4 : strTemp := ' hifi';
            5 : strTemp := ' cd';
            6 : strTemp := ' studio';
        end;
        strFinalString := strFinalString + ' --preset ' + strTemp;
    end;

    if rbutCBR.Checked then
        strFinalString := strFinalString + ' -b ' + cbxCBR.text;

    if rbutABR.Checked then
        strFinalString := strFinalString + ' --abr ' + cbxABR.text;

    if rbutVBR.Checked then
    begin
        case cbxVBRMode.ItemIndex of
        0 : strTemp := ' --vbr-new ';
        1 : strTemp := ' --vbr-old ';
        2 : strTemp := ' --vbr-mtrh ';
        end;
        strFinalString := strFinalString + strTemp + ' -V '
            + cbxVBRQuality.Text + ' -b ' + cbxMinBitrate.Text
            + ' -B ' + cbxMaxBitrate.Text;

        if flgSupport.Checked then
            strFinalString := strFinalString + ' -F';

        if flgLameTagDis.Checked then
            strFinalString := strFinalString + ' -t';

        if flgHist.Checked then
            strFinalString := strFinalString + ' --nohist';
    end;

    if cbxEmp.Text <> '' then
        strFinalString := strFinalString + ' -e ' + cbxEmp.Text;

    if flgCopyright.Checked then
        strFinalString := strFinalString + ' -c';

    if flgNonOriginal.Checked then
        strFinalString := strFinalString + ' -o';

    if flgErrorProtection.Checked then
        strFinalString := strFinalString + ' -p';

    if flgBitRes.Checked then
        strFinalString := strFinalString + ' --nores';

    if flgMaxISO.Checked then
        strFinalString := strFinalString + ' --strictly-enforce-ISO';

    if cbxNoise.Text <> '5' then
        strFinalString := strFinalString + ' -q ' + cbxNoise.Text;

    if not flgNoFilter.Checked then
    begin
        strTemp := trim(edtLowPass.Text);
        if strTemp <> '' then
            strFinalString := strFinalString + ' --lowpass ' + strTemp;

        strTemp := trim(edtLowPassWidth.Text);
        if strTemp <> '' then
            strFinalString := strFinalString + ' --lowpass-width ' + strTemp;

        strTemp := trim(edtHighPass.Text);
        if strTemp <> '' then
            strFinalString := strFinalString + ' --highpass ' + strTemp;

        strTemp := trim(edtHighPassWidth.Text);
        if strTemp <> '' then
            strFinalString := strFinalString + ' --highpass-width ' + strTemp;

        strTemp := trim(edtOutputSample.Text);
        if strTemp <> '' then
            strFinalString := strFinalString + ' --resample ' + strTemp;

        strTemp := trim(edtTonality.Text);
        if strTemp <> '' then
            strFinalString := strFinalString + ' --cwlimit ' + strTemp;
    end
    else
        strFinalString := strFinalString + ' -k';

    if flgNoProgress.Checked then
        strFinalString := strFinalString + ' -S';

    if flgAllUseFull.Checked then
        strFinalString := strFinalString + ' --verbose';

    if flgBlankScreen.Checked then
        strFinalString := strFinalString + ' --silent';

    strTemp := trim(edtSongName.Text);
    if strTemp <> '' then
    begin
       if pos(' ', strTemp) <> 0 then
          strTempID3 := ' --tt ' + '"' + strTemp + '"'
       else
          strTempID3 := ' --tt ' + strTemp;
    end;

    strTemp := trim(edtArtist.Text);
    if strTemp <> '' then
    begin
       if pos(' ', strTemp) <> 0 then
          strTempID3 := strTempID3 + ' --ta ' + '"' + strTemp + '"'
       else
          strTempID3 := strTempID3 + ' --ta ' + strTemp;
    end;

    strTemp := trim(edtAlbum.Text);
    if strTemp <> '' then
    begin
       if pos(' ', strTemp) <> 0 then
          strTempID3 := strTempID3 + ' --tl ' + '"' + strTemp + '"'
       else
          strTempID3 := strTempID3 + ' --tl ' + strTemp;
    end;

    strTemp := trim(edtYear.Text);
    if strTemp <> '' then
        strTempID3 := strTempID3 + ' --ty ' + strTemp;

    strTemp := trim(edtTrackNumber.Text);
    if strTemp <> '' then
        strTempID3 := strTempID3 + ' --tn ' + strTemp;

    strTemp := trim(cbxGenre.Text);
    if strTemp <> '' then
    begin
       if pos(' ', strTemp) <> 0 then
          strTempID3 := strTempID3 + ' --tg ' + '"' + strTemp + '"'
       else
          strTempID3 := strTempID3 + ' --tg ' + strTemp;
    end;

    strTemp := trim(edtComment.Text);
    if strTemp <> '' then
    begin
       if pos(' ', strTemp) <> 0 then
          strTempID3 := strTempID3 + ' --tc ' + '"' + strTemp + '"'
       else
          strTempID3 := strTempID3 + ' --tc ' + strTemp;
    end;

    strFinalString := strFinalString + strTempID3;

    if rbut1stOnly.Checked then
        strFinalString := strFinalString + ' --id3v1-only';

    if flg1stEmpty.Enabled and flg1stEmpty.Checked then
        strFinalString := strFinalString + ' --space-id3v1';

    if rbut2ndOnly.Checked then
        strFinalString := strFinalString + ' --id3v2-only';

    if flg2ndEmpty.Enabled and flg2ndEmpty.Checked then
        strFinalString := strFinalString + ' --pad-id3v2';

    if rbutBoth.Checked then
        strFinalString := strFinalString + ' --add-id3v2';

    strTemp := trim(edtInput.Text);
    if strTemp <> '' then
    begin
        if pos(' ', strTemp) <> 0 then
            strFinalString := strFinalString + ' "' + strTemp + '"'
        else
            strFinalString := strFinalString + ' ' + strTemp;
    end;

    strTemp := trim(edtOutput.Text);
    if strTemp <> '' then
    begin
        if pos(' ', strTemp) <> 0 then
            strFinalString := strFinalString + ' "' + strTemp + '"'
        else
            strFinalString := strFinalString + ' ' + strTemp;
    end;


    edtCommandLine.Text := strFinalString;
end;
end;

procedure TForm1.butLameOpenClick(Sender: TObject);
begin
dlgOpen.Title := strdlgLame; //'   lame.exe';
dlgOpen.Filter := strdlgLameFilter; //' lame.exe|lame.exe';

if dlgOpen.Execute then
begin
    strLamePath := dlgOpen.FileName;
    SetCommandLine();
end;

end;

procedure TForm1.butInputOpenClick(Sender: TObject);

var strTemp : String;
    intTemp : Integer;

begin
dlgOpen.Title := strdlgOpen; //'    ';
dlgOpen.Filter := strdlgFileFilter; //'  WAV|*.wav; *.mpa| MP3|*.mp3| |*.*';
dlgOpen.FileName := '';

if dlgOpen.Execute then
begin
    edtInput.Text := dlgOpen.FileName;
    intTemp := pos('.', edtInput.Text);
    strTemp := leftstr(edtInput.Text, intTemp);
    edtOutput.Text := strTemp + 'mp3';
end;

if flgDefault.Checked then
    SetDefaultCommandLine()
else
    SetCommandLine();

end;

procedure TForm1.rgpOutputTypeClick(Sender: TObject);
begin
//if rgpOutputType.ItemIndex = 3 then
//    flgMonoDownmix.Enabled := True
//else
//    flgMonoDownmix.Enabled := False;
SetCommandLine();
end;

procedure TForm1.flgMP3DecodeClick(Sender: TObject);
begin
flgWavHeader.Enabled := flgMP3Decode.Checked;
SetCommandLine();
end;

procedure TForm1.flgUseATHMaskClick(Sender: TObject);
begin
if flgUseATHMask.Checked then
begin
    flgNoATH.Checked := False;
    edtATH.Enabled := True;
end;
SetCommandLine();
end;

procedure TForm1.flgNoATHClick(Sender: TObject);
begin
if flgNoATH.Checked then
begin
    flgUseATHMask.Checked := False;
    edtATH.Enabled := False;
end;
SetCommandLine();
end;

procedure TForm1.flgPresetsClick(Sender: TObject);
begin
cbxPresets.Enabled := flgPresets.Checked;
SetCommandLine();
end;

procedure TForm1.flgDefaultClick(Sender: TObject);
begin
tabBitrate.Enabled := Not flgDefault.Checked;
tabFilter.Enabled := Not flgDefault.Checked;
//tabComment.Enabled := Not flgDefault.Checked;
flgDiffBlock.Enabled := Not flgDefault.Checked;
edtStat.Enabled := Not flgDefault.Checked;
flgVorbis.Enabled := Not flgDefault.Checked;
flgFreeformat.Enabled := Not flgDefault.Checked;
flgCompRatio.Enabled := Not flgDefault.Checked;
flgScale.Enabled := Not flgDefault.Checked;
edtScale.Enabled := Not flgDefault.Checked;
flgUseATHMask.Enabled := Not flgDefault.Checked;
flgNoATH.Enabled := Not flgDefault.Checked;
edtATH.Enabled := Not flgDefault.Checked;
flgTempMask.Enabled := Not flgDefault.Checked;
flgShortBlock.Enabled := Not flgDefault.Checked;
flgVoiceMode.Enabled := Not flgDefault.Checked;
flgPresets.Enabled := Not flgDefault.Checked;
rgpOutputType.Enabled := Not flgDefault.Checked;
label3.Enabled := Not flgDefault.Checked;
label4.Enabled := Not flgDefault.Checked;
flgMP3Decode.Enabled := Not flgDefault.Checked;
label5.Enabled := Not flgDefault.Checked;
label6.Enabled := Not flgDefault.Checked;

if flgDefault.Checked then
    SetDefaultCommandLine()
else
    SetCommandLine();

end;

procedure TForm1.rbutCBRClick(Sender: TObject);
begin
grpABR.Enabled := False;
grpVBR.Enabled := False;
grpCBR.Enabled := True;
SetCommandLine();
end;

procedure TForm1.rbutABRClick(Sender: TObject);
begin
grpABR.Enabled := True;
grpVBR.Enabled := False;
grpCBR.Enabled := False;
SetCommandLine();
end;

procedure TForm1.rbutVBRClick(Sender: TObject);
begin
grpABR.Enabled := False;
grpVBR.Enabled := True;
grpCBR.Enabled := False;
SetCommandLine();
end;

procedure TForm1.flgNoFilterClick(Sender: TObject);
begin
grpFilter.Enabled := Not flgNoFilter.Checked;
SetCommandLine();
end;

procedure TForm1.rbut1stOnlyClick(Sender: TObject);
begin
flg2ndEmpty.Enabled := not rbut1stOnly.Checked;
flg1stEmpty.Enabled := not rbut2ndOnly.Checked;
SetCommandLine();
end;

procedure TForm1.rbut2ndOnlyClick(Sender: TObject);
begin
flg1stEmpty.Enabled := not rbut2ndOnly.Checked;
flg2ndEmpty.Enabled := not rbut1stOnly.Checked;
SetCommandLine();
end;

procedure TForm1.rbutBothClick(Sender: TObject);
begin
flg1stEmpty.Enabled := true;
flg2ndEmpty.Enabled := true;
SetCommandLine();
end;

procedure TForm1.rgrInputTypeClick(Sender: TObject);
begin
if rgrInputType.ItemIndex = 4 then
   flgMonoDownmix.Enabled := True
else
   flgMonoDownmix.Enabled := False;
    
SetCommandLine();
end;

procedure TForm1.cbxSampleFreqChange(Sender: TObject);
begin
SetCommandLine();
end;

procedure TForm1.flgForceInputClick(Sender: TObject);
begin
SetCommandLine();
end;

procedure TForm1.butOutputPathClick(Sender: TObject);
begin
dlgSave.Title := strdlgChange; //'  ';
dlgSave.Filter := strdlgFileFilter; //' *.wav|*.wav| *.mp3| *.mp3| |*.*';
dlgSave.FileName := edtOutput.Text;

if dlgSave.Execute then
begin
    edtOutput.Text := dlgSave.FileName;
end;

if flgDefault.Checked then
    SetDefaultCommandLine()
else
    SetCommandLine();

end;

procedure TForm1.flgMonoDownmixClick(Sender: TObject);
begin
SetCommandLine();
end;

procedure TForm1.flgDiffBlockClick(Sender: TObject);
begin
SetCommandLine();
end;

procedure TForm1.edtStatChange(Sender: TObject);
begin
SetCommandLine();
end;

procedure TForm1.flgVorbisClick(Sender: TObject);
begin
SetCommandLine();
end;

procedure TForm1.flgFreeformatClick(Sender: TObject);
begin
SetCommandLine();
end;

procedure TForm1.flgWavHeaderClick(Sender: TObject);
begin
SetCommandLine();
end;

procedure TForm1.flgCompRatioClick(Sender: TObject);
begin
edtCompRatio.Enabled := flgCompRatio.Checked;
SetCommandLine();
end;

procedure TForm1.edtCompRatioChange(Sender: TObject);
begin
SetCommandLine();
end;

procedure TForm1.flgScaleClick(Sender: TObject);
begin
edtScale.Enabled := flgScale.Checked;
SetCommandLine();
end;

procedure TForm1.edtScaleChange(Sender: TObject);
begin
SetCommandLine();
end;

procedure TForm1.edtATHChange(Sender: TObject);
begin
SetCommandLine();
end;

procedure TForm1.flgTempMaskClick(Sender: TObject);
begin
SetCommandLine();
end;

procedure TForm1.flgShortBlockClick(Sender: TObject);
begin
SetCommandLine();
end;

procedure TForm1.flgVoiceModeClick(Sender: TObject);
begin
SetCommandLine();
end;

procedure TForm1.cbxPresetsChange(Sender: TObject);
begin
SetCommandLine();
end;

procedure TForm1.cbxCBRChange(Sender: TObject);
begin
SetCommandLine();
end;

procedure TForm1.cbxABRChange(Sender: TObject);
begin
SetCommandLine();
end;

procedure TForm1.cbxVBRModeChange(Sender: TObject);
begin
SetCommandLine();
end;

procedure TForm1.cbxVBRQualityChange(Sender: TObject);
begin
SetCommandLine();
end;

procedure TForm1.cbxMinBitrateChange(Sender: TObject);
begin
SetCommandLine();
end;

procedure TForm1.cbxMaxBitrateChange(Sender: TObject);
begin
SetCommandLine();
end;

procedure TForm1.flgSupportClick(Sender: TObject);
begin
SetCommandLine();
end;

procedure TForm1.flgLameTagDisClick(Sender: TObject);
begin
SetCommandLine();
end;

procedure TForm1.flgHistClick(Sender: TObject);
begin
SetCommandLine();
end;

procedure TForm1.flgCopyrightClick(Sender: TObject);
begin
SetCommandLine();
end;

procedure TForm1.flgNonOriginalClick(Sender: TObject);
begin
SetCommandLine();
end;

procedure TForm1.flgErrorProtectionClick(Sender: TObject);
begin
SetCommandLine();
end;

procedure TForm1.flgBitResClick(Sender: TObject);
begin
SetCommandLine();
end;

procedure TForm1.flgMaxISOClick(Sender: TObject);
begin
SetCommandLine();
end;

procedure TForm1.cbxEmpChange(Sender: TObject);
begin
SetCommandLine();
end;

procedure TForm1.cbxNoiseChange(Sender: TObject);
begin
SetCommandLine();
end;

procedure TForm1.edtLowPassChange(Sender: TObject);

begin
SetCommandLine();
end;

procedure TForm1.edtLowPassWidthChange(Sender: TObject);
begin
SetCommandLine();
end;

procedure TForm1.edtHighPassChange(Sender: TObject);
begin
SetCommandLine();
end;

procedure TForm1.edtHighPassWidthChange(Sender: TObject);
begin
SetCommandLine();
end;

procedure TForm1.edtOutputSampleChange(Sender: TObject);
begin
SetCommandLine();
end;

procedure TForm1.edtTonalityChange(Sender: TObject);
begin
SetCommandLine();
end;

procedure TForm1.flgNoProgressClick(Sender: TObject);
begin
SetCommandLine();
end;

procedure TForm1.flgAllUseFullClick(Sender: TObject);
begin
SetCommandLine();
end;

procedure TForm1.flgBlankScreenClick(Sender: TObject);
begin
SetCommandLine();
end;

procedure TForm1.edtSongNameChange(Sender: TObject);
begin
SetCommandLine();
end;

procedure TForm1.edtArtistChange(Sender: TObject);
begin
SetCommandLine();
end;

procedure TForm1.edtAlbumChange(Sender: TObject);
begin
SetCommandLine();
end;

procedure TForm1.edtYearChange(Sender: TObject);
begin
SetCommandLine();
end;

procedure TForm1.edtTrackNumberChange(Sender: TObject);
begin
SetCommandLine();
end;

procedure TForm1.cbxGenreChange(Sender: TObject);
begin
SetCommandLine();
end;

procedure TForm1.edtCommentChange(Sender: TObject);
begin
SetCommandLine();
end;

procedure TForm1.flg1stEmptyClick(Sender: TObject);
begin
SetCommandLine();
end;

procedure TForm1.flg2ndEmptyClick(Sender: TObject);
begin
SetCommandLine();
end;

procedure TForm1.butExitClick(Sender: TObject);
begin
Beep();
if messagedlg(strEndProgram,mtConfirmation,mbOKCancel,0) = mrOk then
    Application.Terminate
end;

procedure TForm1.butReadyClick(Sender: TObject);

var strTemp : string;

begin
if strLamePath = '' then
begin
    ShowMessage(strNoLamePath);
//    butLameOpen.SetFocus;
    Exit;
end;

if edtInput.Text = '' then
begin
    ShowMessage(strNoInputFile);
    tabInput.Show;
    butInputOpen.SetFocus;
    Exit;
end;

if edtOutput.Text = '' then
begin
    ShowMessage(strNoOutputFile);
    tabOutput.Show;
    butOutputPath.SetFocus;
    Exit;
end;

if messagedlg(strRun,mtConfirmation,mbOKCancel,0)
                = mrOk then
begin
    strTemp := edtCommandLine.Text;
//    if flgAll2File.Checked then
//        strTemp := strTemp;
    winexec(PChar(strTemp), SW_SHOWNORMAL);    
end;
end;

procedure TForm1.FormCreate(Sender: TObject);

var
  Registry: TRegistry;
  intLeftPos: Integer;
  intTopPos: Integer;
  regType: TRegDataType;

begin
edtCommandLine.Text := '';
Application.OnHint := PanelHint;

  Registry := TRegistry.Create;
  Registry.RootKey:=HKEY_CURRENT_USER;
  Registry.OpenKey('\Software\LameGUI',True);

  regType := Registry.GetDataType('LeftPos');
  if regType = rdInteger then
     intLeftPos := Registry.ReadInteger('LeftPos')
  else
     intLeftPos := -1;

  regType := Registry.GetDataType('TopPos');
  if regType = rdInteger then
     intTopPos := Registry.ReadInteger('TopPos')
  else
     intTopPos := -1;

  regType := Registry.GetDataType('LamePath');
  if regType = rdString then
     strLamePath := Registry.ReadString('LamePath')
  else
     strLamePath := '';

  regType := Registry.GetDataType('Language');
  if regType = rdInteger then
     bytLanguage := Registry.ReadInteger('Language')
  else
     bytLanguage := 0;

  Registry.Free;

  if intLeftPos > 0 then
     Form1.Left := intLeftPos
  else
     Form1.Left := (Screen.Width - Form1.Width) div 2;

  if intTopPos > 0 then
     Form1.Top := intTopPos
  else
     Form1.Top := (Screen.Height - Form1.Height) div 2;

  SwitchLanguage();
end;

procedure TForm1.PanelHint(Sender: TObject);
begin
    stsString.Panels[0].Text := Application.Hint;
end;
procedure TForm1.mnuSaveClick(Sender: TObject);

var strTemp: String;
    cfLameSets: TIniFile;

begin
dlgSave.Title := strdlgSaveConf;
dlgSave.Filter := strdlgFilterConf;
//dlgSave.FileName := edtOutput.Text;

if dlgSave.Execute then
begin
    strTemp := dlgSave.FileName;
    cfLameSets := TIniFile.Create(strTemp);
    cfLameSets.WriteString('Lame GUI Sets', 'LamePath', strLamePath);
    cfLameSets.WriteInteger('Lame GUI Sets', 'InputType', rgrInputType.ItemIndex);
    cfLameSets.WriteString('Lame GUI Sets', 'SampleFrequency', cbxSampleFreq.Text);
    cfLameSets.WriteBool('Lame GUI Sets', 'ForceInput', flgForceInput.Checked);
    cfLameSets.WriteInteger('Lame GUI Sets', 'OutputType', rgpOutputType.ItemIndex);
    cfLameSets.WriteBool('Lame GUI Sets', 'MonoDownmix', flgMonoDownmix.Checked);
    cfLameSets.WriteBool('Lame GUI Sets', 'DifferentBlocks', flgDiffBlock.Checked);
    cfLameSets.WriteString('Lame GUI Sets', 'StatDisplay', edtStat.Text);
    cfLameSets.WriteBool('Lame GUI Sets', 'OggVorbis', flgVorbis.Checked);
    cfLameSets.WriteBool('Lame GUI Sets', 'FreeFormat', flgFreeformat.Checked);
    cfLameSets.WriteBool('Lame GUI Sets', 'MP3Decoding', flgMP3Decode.Checked);
    cfLameSets.WriteBool('Lame GUI Sets', 'NoWAVHeader', flgWavHeader.Checked);
    cfLameSets.WriteBool('Lame GUI Sets', 'UseCompressionRatio', flgCompRatio.Checked);
    cfLameSets.WriteString('Lame GUI Sets', 'CompressionRatio', edtCompRatio.Text);
    cfLameSets.WriteBool('Lame GUI Sets', 'UseScale', flgScale.Checked);
    cfLameSets.WriteString('Lame GUI Sets', 'Scale', edtScale.Text);
    cfLameSets.WriteBool('Lame GUI Sets', 'UseATH4Masking', flgUseATHMask.Checked);
    cfLameSets.WriteBool('Lame GUI Sets', 'NotUseATH', flgNoATH.Checked);
    cfLameSets.WriteString('Lame GUI Sets', 'ATH', edtATH.Text);
    cfLameSets.WriteBool('Lame GUI Sets', 'UseTemporaryMasking', flgTempMask.Checked);
    cfLameSets.WriteBool('Lame GUI Sets', 'UseShortBlocks', flgShortBlock.Checked);
    cfLameSets.WriteBool('Lame GUI Sets', 'VoiceMode', flgVoiceMode.Checked);
    cfLameSets.WriteBool('Lame GUI Sets', 'UsePresets', flgPresets.Checked);
    cfLameSets.WriteString('Lame GUI Sets', 'Presets', cbxPresets.Text);
    cfLameSets.WriteBool('Lame GUI Sets', 'Default', flgDefault.Checked);
    cfLameSets.WriteBool('Lame GUI Sets', 'CBR', rbutCBR.Checked);
    cfLameSets.WriteString('Lame GUI Sets', 'CBRValue', cbxCBR.Text);
    cfLameSets.WriteBool('Lame GUI Sets', 'ABR', rbutABR.Checked);
    cfLameSets.WriteString('Lame GUI Sets', 'ABRValue', cbxABR.Text);
    cfLameSets.WriteBool('Lame GUI Sets', 'VBR', rbutVBR.Checked);
    cfLameSets.WriteString('Lame GUI Sets', 'VBRMode', cbxVBRMode.Text);
    cfLameSets.WriteString('Lame GUI Sets', 'VBRQuality', cbxVBRQuality.Text);
    cfLameSets.WriteString('Lame GUI Sets', 'VBRMinBitrate', cbxMinBitrate.Text);
    cfLameSets.WriteString('Lame GUI Sets', 'VBRMaxBitrate', cbxMaxBitrate.Text);
    cfLameSets.WriteBool('Lame GUI Sets', 'Support', flgSupport.Checked);
    cfLameSets.WriteBool('Lame GUI Sets', 'LameTagDis', flgLameTagDis.Checked);
    cfLameSets.WriteBool('Lame GUI Sets', 'ShowHistogramm', flgHist.Checked);
    cfLameSets.WriteBool('Lame GUI Sets', 'Copyright', flgCopyright.Checked);
    cfLameSets.WriteBool('Lame GUI Sets', 'NonOriginal', flgNonOriginal.Checked);
    cfLameSets.WriteBool('Lame GUI Sets', 'ErrorProtection', flgErrorProtection.Checked);
    cfLameSets.WriteBool('Lame GUI Sets', 'OffReservBit', flgBitRes.Checked);
    cfLameSets.WriteBool('Lame GUI Sets', 'MaxISOCompliance', flgMaxISO.Checked);
    cfLameSets.WriteString('Lame GUI Sets', 'HighPassFilter', cbxEmp.Text);
    cfLameSets.WriteString('Lame GUI Sets', 'NoiseReduction', cbxNoise.Text);
    cfLameSets.WriteBool('Lame GUI Sets', 'NoFilters', flgNoFilter.Checked);
    cfLameSets.WriteString('Lame GUI Sets', 'LowPassCut', edtLowPass.Text);
    cfLameSets.WriteString('Lame GUI Sets', 'LowPassWidth', edtLowPassWidth.Text);
    cfLameSets.WriteString('Lame GUI Sets', 'HighPassCut', edtHighPass.Text);
    cfLameSets.WriteString('Lame GUI Sets', 'HighPassWidth', edtHighPassWidth.Text);
    cfLameSets.WriteString('Lame GUI Sets', 'OutputSampling', edtOutputSample.Text);
    cfLameSets.WriteString('Lame GUI Sets', 'Tonality', edtTonality.Text);
    cfLameSets.WriteBool('Lame GUI Sets', 'NoProgress', flgNoProgress.Checked);
    cfLameSets.WriteBool('Lame GUI Sets', 'ShowAllUseful', flgAllUseFull.Checked);
    cfLameSets.WriteBool('Lame GUI Sets', 'ShowNothing', flgBlankScreen.Checked);
    cfLameSets.WriteString('Lame GUI Sets', 'Comment', edtComment.Text);
    cfLameSets.WriteBool('Lame GUI Sets', 'ID3Tag1stOnly', rbut1stOnly.Checked);
    cfLameSets.WriteBool('Lame GUI Sets', 'ID3Tag2ndOnly', rbut2ndOnly.Checked);
    cfLameSets.WriteBool('Lame GUI Sets', 'ID3TagBoth', rbutBoth.Checked);
    cfLameSets.WriteBool('Lame GUI Sets', '1stEmpty', flg1stEmpty.Checked);
    cfLameSets.WriteBool('Lame GUI Sets', '2ndEmpty', flg2ndEmpty.Checked);
    cfLameSets.Free;
end;
end;

procedure TForm1.mnuLoadClick(Sender: TObject);

var strTemp: String;
    cfLameSets: TIniFile;

begin
dlgOpen.Title := strdlgRestConf;
dlgOpen.Filter := strdlgFilterConf;
if dlgOpen.Execute then
begin
    strTemp := dlgOpen.FileName;
    cfLameSets := TIniFile.Create(strTemp);
    strLamePath := cfLameSets.ReadString('Lame GUI Sets', 'LamePath', '');
    rgrInputType.ItemIndex := cfLameSets.ReadInteger('Lame GUI Sets', 'InputType', 5);
    cbxSampleFreq.Text := cfLameSets.ReadString('Lame GUI Sets', 'SampleFrequency', '44.1');
    flgForceInput.Checked := cfLameSets.ReadBool('Lame GUI Sets', 'ForceInput', False);
    rgpOutputType.ItemIndex := cfLameSets.ReadInteger('Lame GUI Sets', 'OutputType', 1);
    flgMonoDownmix.Checked := cfLameSets.ReadBool('Lame GUI Sets', 'MonoDownmix', False);
    flgDiffBlock.Checked := cfLameSets.ReadBool('Lame GUI Sets', 'DifferentBlocks', False);
    edtStat.Text := cfLameSets.ReadString('Lame GUI Sets', 'StatDisplay', '');
    flgVorbis.Checked := cfLameSets.ReadBool('Lame GUI Sets', 'OggVorbis', False);
    flgFreeformat.Checked := cfLameSets.ReadBool('Lame GUI Sets', 'FreeFormat', False);
    cfLameSets.ReadBool('Lame GUI Sets', 'MP3Decoding', flgMP3Decode.Checked);
    flgWavHeader.Checked := cfLameSets.ReadBool('Lame GUI Sets', 'NoWAVHeader', False);
    flgCompRatio.Checked := cfLameSets.ReadBool('Lame GUI Sets', 'UseCompressionRatio', False);
    edtCompRatio.Text := cfLameSets.ReadString('Lame GUI Sets', 'CompressionRatio', '');
    flgScale.Checked := cfLameSets.ReadBool('Lame GUI Sets', 'UseScale', False);
    edtScale.Text := cfLameSets.ReadString('Lame GUI Sets', 'Scale', '');
    flgUseATHMask.Checked := cfLameSets.ReadBool('Lame GUI Sets', 'UseATH4Masking', False);
    flgNoATH.Checked := cfLameSets.ReadBool('Lame GUI Sets', 'NotUseATH', False);
    edtATH.Text := cfLameSets.ReadString('Lame GUI Sets', 'ATH', '');
    flgTempMask.Checked := cfLameSets.ReadBool('Lame GUI Sets', 'UseTemporaryMasking', False);
    flgShortBlock.Checked := cfLameSets.ReadBool('Lame GUI Sets', 'UseShortBlocks', False);
    flgVoiceMode.Checked := cfLameSets.ReadBool('Lame GUI Sets', 'VoiceMode', False);
    flgPresets.Checked := cfLameSets.ReadBool('Lame GUI Sets', 'UsePresets', False);
    cbxPresets.Text := cfLameSets.ReadString('Lame GUI Sets', 'Presets', '');
    flgDefault.Checked := cfLameSets.ReadBool('Lame GUI Sets', 'Default', False);
    rbutCBR.Checked := cfLameSets.ReadBool('Lame GUI Sets', 'CBR', True);
    cbxCBR.Text := cfLameSets.ReadString('Lame GUI Sets', 'CBRValue', '128');
    rbutABR.Checked := cfLameSets.ReadBool('Lame GUI Sets', 'ABR', False);
    cbxABR.Text := cfLameSets.ReadString('Lame GUI Sets', 'ABRValue', '128');
    rbutVBR.Checked := cfLameSets.ReadBool('Lame GUI Sets', 'VBR', False);
    cbxVBRMode.Text := cfLameSets.ReadString('Lame GUI Sets', 'VBRMode', '');
    cbxVBRQuality.Text := cfLameSets.ReadString('Lame GUI Sets', 'VBRQuality', '4');
    cbxMinBitrate.Text := cfLameSets.ReadString('Lame GUI Sets', 'VBRMinBitrate', '32');
    cbxMaxBitrate.Text := cfLameSets.ReadString('Lame GUI Sets', 'VBRMaxBitrate', '320');
    flgSupport.Checked := cfLameSets.ReadBool('Lame GUI Sets', 'Support', False);
    flgLameTagDis.Checked := cfLameSets.ReadBool('Lame GUI Sets', 'LameTagDis', False);
    flgHist.Checked := cfLameSets.ReadBool('Lame GUI Sets', 'ShowHistogramm', False);
    flgCopyright.Checked := cfLameSets.ReadBool('Lame GUI Sets', 'Copyright', False);
    flgNonOriginal.Checked := cfLameSets.ReadBool('Lame GUI Sets', 'NonOriginal', False);
    flgErrorProtection.Checked := cfLameSets.ReadBool('Lame GUI Sets', 'ErrorProtection', False);
    flgBitRes.Checked := cfLameSets.ReadBool('Lame GUI Sets', 'OffReservBit', False);
    flgMaxISO.Checked := cfLameSets.ReadBool('Lame GUI Sets', 'MaxISOCompliance', False);
    cbxEmp.Text := cfLameSets.ReadString('Lame GUI Sets', 'HighPassFilter', '');    
    cbxNoise.Text := cfLameSets.ReadString('Lame GUI Sets', 'NoiseReduction', '5');
    flgNoFilter.Checked := cfLameSets.ReadBool('Lame GUI Sets', 'NoFilters', False);
    edtLowPass.Text := cfLameSets.ReadString('Lame GUI Sets', 'LowPassCut', '');
    edtLowPassWidth.Text := cfLameSets.ReadString('Lame GUI Sets', 'LowPassWidth', '');
    edtHighPass.Text := cfLameSets.ReadString('Lame GUI Sets', 'HighPassCut', '');
    edtHighPassWidth.Text := cfLameSets.ReadString('Lame GUI Sets', 'HighPassWidth', '');
    edtOutputSample.Text := cfLameSets.ReadString('Lame GUI Sets', 'OutputSampling', '');
    edtTonality.Text := cfLameSets.ReadString('Lame GUI Sets', 'Tonality', '');
    flgNoProgress.Checked := cfLameSets.ReadBool('Lame GUI Sets', 'NoProgress', False);
    flgAllUseFull.Checked := cfLameSets.ReadBool('Lame GUI Sets', 'ShowAllUseful', False);
    flgBlankScreen.Checked := cfLameSets.ReadBool('Lame GUI Sets', 'ShowNothing', False);
    edtComment.Text := cfLameSets.ReadString('Lame GUI Sets', 'Comment', '');
    rbut1stOnly.Checked := cfLameSets.ReadBool('Lame GUI Sets', 'ID3Tag1stOnly', False);
    rbut2ndOnly.Checked := cfLameSets.ReadBool('Lame GUI Sets', 'ID3Tag2ndOnly', False);
    rbutBoth.Checked := cfLameSets.ReadBool('Lame GUI Sets', 'ID3TagBoth', False);
    flg1stEmpty.Checked := cfLameSets.ReadBool('Lame GUI Sets', '1stEmpty', False);
    flg2ndEmpty.Checked := cfLameSets.ReadBool('Lame GUI Sets', '2ndEmpty', False);
    cfLameSets.Free;
end;
end;

procedure TForm1.flgScaleLeftClick(Sender: TObject);
begin
edtScaleLeft.Enabled := flgScaleLeft.Checked;
SetCommandLine();
end;

procedure TForm1.flgScaleRightClick(Sender: TObject);
begin
edtScaleRight.Enabled := flgScaleRight.Checked;
SetCommandLine();
end;

procedure TForm1.FormDestroy(Sender: TObject);

var
   Reg: TRegistry;

begin
  Reg := TRegistry.Create;
  try
    Reg.RootKey := HKEY_CURRENT_USER;
    if Reg.OpenKey('\Software\LameGUI', True) then
    begin
      Reg.WriteInteger('LeftPos', Form1.Left);
      Reg.WriteInteger('TopPos', Form1.Top);
      Reg.WriteString('LamePath', strLamePath);
      Reg.WriteInteger('Language', bytLanguage);
      Reg.CloseKey;
    end;
  finally
    Reg.Free;
  end;
end;

procedure TForm1.mnuEnglishClick(Sender: TObject);
begin
  bytLanguage := 0;
  SwitchLanguage();
end;

procedure TForm1.mnuRussianClick(Sender: TObject);
begin
   bytLanguage := 1;
   SwitchLanguage();
end;

procedure TForm1.flgReadOnlyClick(Sender: TObject);
begin
edtCommandLine.Enabled := not flgReadOnly.Checked;
end;

end.
